
/*

Shock:
 
 General background.(Includes Newton method)

*/

/*
 
 Direct solver; compute Cheb internally; variable precision
 
*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>


#define RICCIFLOW  0

double k1 = 0. ;
double k2 = 0. ;

double r1 = 0.65 ;
double r2 = 0.667127 ;

double z1 = 1. ;
double z2 = 1.00994 ;


double zmax = 1.1 ;

/*
double k1 = 0.1 ;
double k2 = 0. ;

double r1 = 0.4 ;
double r2 = 0.4 ;

double z1 = 1. ;
double z2 = 1. ;


double zmax = 1.2 ;
*/


/*
double boost1 = 0.62 ;
double z0pos1 = 1. ;

double boost2 = 0.700713 ;
double z0pos2 = 1.04768 ;
*/

/*
double boost1 = 0.55 ;
double z0pos1 = 1. ;

double boost2 = 0.803473 ;
double z0pos2 = 1.15701 ;
*/




#define LAPACK  1


#define Power(x,n) powl(x,n)
#define Sqrt(x)    sqrtl(x)
#define Cosh(x)    coshl(x)
#define Sinh(x)    sinhl(x)
#define Tanh(x)    tanhl(x)
#define Tan(x)     tanl(x)

#define Sech(x)    (1./coshl(x))
#define Sec(x)     (1./cosl(x))
#define Cos(x)     cosl(x)


#define PI 3.1415926535897932384626433832795028841971693993751L

#define Pi PI

#define LICHCUT 0.


#define NMAX  100
#define NMAX2 20000
#define NMAX3 100000000


double multval = -1. ;


int    NZ,NX ;

double   patch[NMAX][NMAX][2] ;
long   mask[7][NMAX][NMAX] ;
int    vecpos[NMAX2][3] ;
long   vecsize, sizeLich ;

double   vecR[NMAX2], vecG[NMAX2], vecbuf[NMAX2] ;

int    LichRow[NMAX3], LichCol[NMAX3] ;
double   Lich[NMAX3] ;

double   *Lmat ;

double phimax, Riccimax, R2max ;

double DZmat[NMAX][NMAX], DZ2mat[NMAX][NMAX], DXmat[NMAX][NMAX], DX2mat[NMAX][NMAX] ;

double gmet[7][NMAX][NMAX], g0met[7][NMAX][NMAX] ; 
double RF[7][NMAX][NMAX] ;
double phi[NMAX][NMAX], Ricci[NMAX][NMAX], R2sqr[NMAX][NMAX], C4sqr[NMAX][NMAX] ;

double dvz[7][NMAX][NMAX], dvx[7][NMAX][NMAX], dvzz[7][NMAX][NMAX], dvxx[7][NMAX][NMAX], dvzx[7][NMAX][NMAX] ;

double dv0z[7][NMAX][NMAX], dv0x[7][NMAX][NMAX], dv0zz[7][NMAX][NMAX], dv0xx[7][NMAX][NMAX], dv0zx[7][NMAX][NMAX] ;


void initpatches(void), init(void), save(void) ;
void calcRicciFlow(double *), calcLich(void) ;

void calcPhi(void) ;

void getG(void), storeG(void), updateG(double, double *) ;


FILE *fileptr, *fileptrphi, *fileptrRicci, *fileptrR2sqr, *fileptrC4sqr, *fileptrDerivs ;


void unpackLich(void) ;

void linsolve(double *,double *), linsolvechk(double *,double *) ;
double norm(double *) ;


void setupgrid(void) ;

int status ;


int main (int argc, const char * argv[]) 
{
	int iter, err ;
	double rad,multiplier,residual,Rerr, phimax, buf ;
	clock_t firsttime, starttime, time1, time2 ;  
    long Lsize, posii, posjj ;

    int iter2 ;
    double time, DT ;

    printf(" argc = %d\n",argc) ;
    
    if(argc!=8) {
        
        printf("\n\nError in arguments\nUsage:  a.out  k1 k2 r1 r2 z1 z2  zmax  (put 'x' for default value)\n\n") ; exit(1) ;
        
    }
    
    printf(" argv = <%s>  <%s>  <%s>  <%s>  <%s>  <%s>  <%s>\n",argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7]) ;

    err = sscanf(argv[1],"%le",&buf) ;
    if(err==1) { k1 = buf ; printf(" k1 = %7.3e\n",k1) ; }
    else printf(" k1 = %7.3e (default)\n",k1) ;
    
    err = sscanf(argv[2],"%le",&buf) ;
    if(err==1) { k2 = buf ; printf(" k2 = %7.3e\n",k2) ; }
    else printf(" k2 = %7.3e (default)\n",k2) ;

    err = sscanf(argv[3],"%le",&buf) ;
    if(err==1) { r1 = buf ; printf(" r1 = %7.3e\n",r1) ; }
    else printf(" r1 = %7.3e (default)\n",r1) ;

    err = sscanf(argv[4],"%le",&buf) ;
    if(err==1) { r2 = buf ; printf(" r2 = %7.3e\n",r2) ; }
    else printf(" r2 = %7.3e (default)\n",r2) ;

    err = sscanf(argv[5],"%le",&buf) ;
    if(err==1) { z1 = buf ; printf(" z1 = %7.3e\n",z1) ; }
    else printf(" z1 = %7.3e (default)\n",z1) ;

    err = sscanf(argv[6],"%le",&buf) ;
    if(err==1) { z2 = buf ; printf(" z2 = %7.3e\n",z2) ; }
    else printf(" z2 = %7.3e (default)\n",z2) ;

    err = sscanf(argv[7],"%le",&buf) ;
    if(err==1) { zmax = buf ; printf(" zmax = %7.3e\n",zmax) ; }
    else printf(" zmax = %7.3e (default)\n",zmax) ;

  	
	fileptr = fopen("data.out","w") ; fileptrphi = fopen("phi.out","w") ; 
    fileptrRicci = fopen("Ricci.out","w") ; fileptrR2sqr = fopen("R2sqr.out","w") ; fileptrC4sqr = fopen("C4sqr.out","w") ;
    fileptrDerivs = fopen("derivs.out","w") ;
	
	initpatches() ;
    setupgrid() ;
		
	init() ; 
    
    
    
	printf("\n\n ** Initial values:  NZ = %d  NX = %d   z0 = %e\n\n",NZ,NX,zmax) ;	
	
    
    

    printf("\n\nZ coords:\n\n") ;
    for(posii=0;posii<NZ;posii++) printf(" %5.3f",patch[posii][0][0]) ;                               

    printf("\n\nX coords:\n\n") ;
    for(posii=0;posii<NX;posii++) printf(" %5.3f",patch[0][posii][1]) ;                               

    printf("\n\n") ;
    
  
    
#if RICCIFLOW == 1    
    
    printf("\n\nRicci flow:\n\n") ;
    
    DT = 0.1/(NZ*NZ) ;
    
    save() ;	
    
    for(time=0.,iter2=0;iter2<1000;iter2++) {
        
        
        for(iter=0;iter<200;iter++,time+=DT) {
            
            calcRicciFlow(vecR) ;
            
            getG() ;
            
            updateG(-DT,vecR) ;
            
            storeG() ;
            
        }
        
        save() ;	
        
        printf(" ii = %d ; t = %e ; T[zmax,mid] = %e\n",iter2,time,gmet[0][NZ-1][NX/2]) ;
        
    }

     
#else     
    
   
	printf("\n\nNewton solver:\n\n") ;

    
     
    Lsize = vecsize*(vecsize+1)*sizeof(double) ;
    Lmat  = malloc(Lsize) ;
    
    if(Lmat==NULL) {
        
        printf("\n\nCouldn't allocate memory for Lich op matrix\n\n") ;
        
    } else {
        
        printf("\n\nAllocated Lich memory:  %ld  bytes\n\n     %ld  Mb\n\n",Lsize,Lsize/(1000000)) ;
        
    }
    
	multiplier = multval ;

    printf("multiplier %f\n",multiplier) ;

    
	calcRicciFlow(vecR) ;
	
	firsttime = clock() ;
    
    status = 0 ;
    
    Rerr = norm(vecR) ;		
    
    calcPhi() ;
    
    save() ;	
    
    printf("   Initial config:  Rerr = %10.3e  phimax = %10.3e\n",Rerr,phimax) ;
	
	for(iter=0;iter<30;iter++) {
		
        printf("Iteration = %d ;  multiplier = %f  status = %d \n",iter,multiplier,status) ;
        
				
		starttime = clock() ;
				
		printf("  <- ") ; fflush(stdout) ;

		calcRicciFlow(vecR) ;
        
		calcLich() ;	
        
        unpackLich() ;
		
		printf("  ->\n") ;   fflush(stdout) ;
		
		
		time1 = clock() ;
		
		linsolve(vecbuf,vecR) ;
		
               
        unpackLich() ;
		linsolvechk(vecbuf,vecR) ;


		time2 = clock() ;
 		
		
		getG() ;
		
		updateG(multiplier,vecbuf) ;
		
		storeG() ;		
		
		residual = norm(vecbuf) ;
		
		calcRicciFlow(vecR) ;

		Rerr = norm(vecR) ;	
        
        calcPhi() ;

        save() ;	

        
        printf("   Update = %10.3e  Rerr = %10.3e  Phimax = %10.3e  Riccimax = %10.3e  R2max = %10.3e  -- Timings (sec; Lich, Solve): %10.3f %10.3f\n",residual,Rerr,phimax,Riccimax,R2max,(1.*(time1 - starttime))/(1.*CLOCKS_PER_SEC),(1.*(time2 - time1))/(1.*CLOCKS_PER_SEC)) ;
 
        printf("        -> T[zmax,mid] = %e\n",gmet[0][NZ-1][NX/2]) ;

        
        if(residual<1e-4 && status==0) {
			status = 1 ;
		}
         
		
		if(residual<1e-9) {
			printf("*** Finished\n") ; break ;
		}
				
	}
		
	printf("   Total Time: %10.3f (min)\n",(1./60.*(clock() - firsttime))/(1.*CLOCKS_PER_SEC)) ;
	
    
    unpackLich() ;
	save() ;	
	
   
    
	free(Lmat) ;
    
   
    
#endif     
    
	
	fclose(fileptr) ;  fclose(fileptrphi) ; 
    fclose(fileptrRicci) ; fclose(fileptrR2sqr) ; fclose(fileptrC4sqr) ; 
    fclose(fileptrDerivs) ;
	
	
	return 0;
	
}




void init(void)
{
	int ii, jj, kk, var ;
    
    double z, x ;
    
    double T, V, B, S, F, U, A ;
    
    double T1, V1, B1, S1, F1, U1, A1 ;
    double T2, V2, B2, S2, F2, U2, A2 ;
    
    double a, k, z0, r ;
    
    for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
            
			for(var=0;var<7;var++) { 
                gmet[var][ii][jj] = 0 ; 
                RF[var][ii][jj]   = 0 ;
			}
            
            z = patch[ii][jj][0] ; x = patch[ii][jj][1] ;

            if(jj==0) 
                a = 0. ;
            else if(jj==NX-1)
                a = 1. ;
            else
                a = (1 + Tanh(2*Tan((Pi*x)/2.)))/2. ;
            
            k = k1 ; z0 = z1 ; r = r1 ;
            
            T1 = (Power(-1 + k*z,4)*Power(z0,4) - Power(z,4)*Power(Cosh(r),2))/(Power(-1 + k*z,2)*Power(z0,4)) ;
			V1 = Cosh(r) ;
            B1 = (Power(-1 + k*z,4)*Power(z0,4) + Power(z,4)*Power(Sinh(r),2))/(Power(-1 + k*z,2)*Power(z0,4)) ;
            S1 = Power(-1 + k*z,2) ;
            F1 = -((Power(-1 + k*z,2)*Power(z0,4)*Sinh(r))/(Power(-1 + k*z,4)*Power(z0,4) + Power(z,4)*Power(Sinh(r),2))) ;
            U1 = (Power(z,4)*Cosh(r)*Sinh(r))/(Power(-1 + k*z,2)*Power(z0,4)) ;
            A1 = -((Power(-1 + k*z,2)*Power(z0,4)*Power(Sinh(r),2))/(Power(-1 + k*z,4)*Power(z0,4) + Power(z,4)*Power(Sinh(r),2))) ;

            k = k2 ; z0 = z2 ; r = r2 ;
            
            T2 = (Power(-1 + k*z,4)*Power(z0,4) - Power(z,4)*Power(Cosh(r),2))/(Power(-1 + k*z,2)*Power(z0,4)) ;
			V2 = Cosh(r) ;
            B2 = (Power(-1 + k*z,4)*Power(z0,4) + Power(z,4)*Power(Sinh(r),2))/(Power(-1 + k*z,2)*Power(z0,4)) ;
            S2 = Power(-1 + k*z,2) ;
            F2 = -((Power(-1 + k*z,2)*Power(z0,4)*Sinh(r))/(Power(-1 + k*z,4)*Power(z0,4) + Power(z,4)*Power(Sinh(r),2))) ;
            U2 = (Power(z,4)*Cosh(r)*Sinh(r))/(Power(-1 + k*z,2)*Power(z0,4)) ;
            A2 = -((Power(-1 + k*z,2)*Power(z0,4)*Power(Sinh(r),2))/(Power(-1 + k*z,4)*Power(z0,4) + Power(z,4)*Power(Sinh(r),2))) ;

            T  = (1 - a)*T1 + a*T2 ;
            V  = (1 - a)*V1 + a*V2 ;
            B  = (1 - a)*B1 + a*B2 ;
            S  = (1 - a)*S1 + a*S2 ;
            F  = (1 - a)*F1 + a*F2 ;
            U  = (1 - a)*U1 + a*U2 ;
            A  = (1 - a)*A1 + a*A2 ;
            
            gmet[0][ii][jj] = T ;
            gmet[1][ii][jj] = V ;
            gmet[2][ii][jj] = B ; 
            gmet[3][ii][jj] = S ;
            gmet[4][ii][jj] = F ;
            gmet[5][ii][jj] = U ;
            gmet[6][ii][jj] = A ;
            
            g0met[0][ii][jj] = T ;
            g0met[1][ii][jj] = V ;
            g0met[2][ii][jj] = B ; 
            g0met[3][ii][jj] = S ;
            g0met[4][ii][jj] = F ;
            g0met[5][ii][jj] = U ;
            g0met[6][ii][jj] = A ;
			
            
		}
	}
    
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			for(var=0;var<7;var++) {
				
				dv0z[var][ii][jj] = 0 ;
				for(kk=0;kk<NZ;kk++) dv0z[var][ii][jj] += DZmat[ii][kk]*g0met[var][kk][jj] ;
				
				dv0x[var][ii][jj] = 0 ;
				for(kk=0;kk<NX;kk++) dv0x[var][ii][jj] += DXmat[jj][kk]*g0met[var][ii][kk] ;
				
				dv0zz[var][ii][jj] = 0 ;
				for(kk=0;kk<NZ;kk++) dv0zz[var][ii][jj] += DZ2mat[ii][kk]*g0met[var][kk][jj] ;
				
				dv0xx[var][ii][jj] = 0 ;
				for(kk=0;kk<NX;kk++) dv0xx[var][ii][jj] += DX2mat[jj][kk]*g0met[var][ii][kk] ;
                
				
			}
			
		}	
		
	}
	
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			for(var=0;var<7;var++) {
				
				dv0zx[var][ii][jj] = 0 ;
				for(kk=0;kk<NZ;kk++) dv0zx[var][ii][jj] += DZmat[ii][kk]*dv0x[var][kk][jj] ;
				
			}
			
		}	
		
	}
    
}




void calcRicciFlow(double *vecRptr)
{
	int ii, jj, var, kk ;
	long pos ;
	
	double val ;
	
	double EqX[7] ;
	
	double z, x ;
	
	double T, Tz, Tx, Tzz, Txx, Tzx ;
	double V, Vz, Vx, Vzz, Vxx, Vzx ;
	double B, Bz, Bx, Bzz, Bxx, Bzx ;
	double S, Sz, Sx, Szz, Sxx, Szx ;
	double F, Fz, Fx, Fzz, Fxx, Fzx ;
	double U, Uz, Ux, Uzz, Uxx, Uzx ;
	double A, Az, Ax, Azz, Axx, Azx ;

    double T0, T0z, T0x, T0zz, T0xx, T0zx ;
	double V0, V0z, V0x, V0zz, V0xx, V0zx ;
	double B0, B0z, B0x, B0zz, B0xx, B0zx ;
	double S0, S0z, S0x, S0zz, S0xx, S0zx ;
	double F0, F0z, F0x, F0zz, F0xx, F0zx ;
	double U0, U0z, U0x, U0zz, U0xx, U0zx ;
	double A0, A0z, A0x, A0zz, A0xx, A0zx ;
    
	
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			for(var=0;var<7;var++) {
				
				dvz[var][ii][jj] = 0 ;
				for(kk=0;kk<NZ;kk++) dvz[var][ii][jj] += DZmat[ii][kk]*gmet[var][kk][jj] ;
				
				dvx[var][ii][jj] = 0 ;
				for(kk=0;kk<NX;kk++) dvx[var][ii][jj] += DXmat[jj][kk]*gmet[var][ii][kk] ;
				
				dvzz[var][ii][jj] = 0 ;
				for(kk=0;kk<NZ;kk++) dvzz[var][ii][jj] += DZ2mat[ii][kk]*gmet[var][kk][jj] ;
				
				dvxx[var][ii][jj] = 0 ;
				for(kk=0;kk<NX;kk++) dvxx[var][ii][jj] += DX2mat[jj][kk]*gmet[var][ii][kk] ;
                
				
			}
			
		}	
		
	}
    
    
    
    
	
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			for(var=0;var<7;var++) {
				
				dvzx[var][ii][jj] = 0 ;
				for(kk=0;kk<NZ;kk++) dvzx[var][ii][jj] += DZmat[ii][kk]*dvx[var][kk][jj] ;
				
			}
			
		}	
		
	}
	
	
	
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
            
			
            if(jj==0 && ii>0) {
                
                z=patch[ii][jj][0] ; x=patch[ii][jj][1] ;

                T = gmet[0][ii][jj] ; Tx = dvx[0][ii][jj] ;
                V = gmet[1][ii][jj] ; Vx = dvx[1][ii][jj] ; 
                B = gmet[2][ii][jj] ; Bx = dvx[2][ii][jj] ; 
                S = gmet[3][ii][jj] ; Sx = dvx[3][ii][jj] ; 	
                F = gmet[4][ii][jj] ; Fx = dvx[4][ii][jj] ; 
                U = gmet[5][ii][jj] ; Ux = dvx[5][ii][jj] ; 
                A = gmet[6][ii][jj] ; Ax = dvx[6][ii][jj] ; 

                T0 = g0met[0][ii][jj] ; 
                V0 = g0met[1][ii][jj] ; 
                B0 = g0met[2][ii][jj] ; 
                S0 = g0met[3][ii][jj] ; 	
                F0 = g0met[4][ii][jj] ; 
                U0 = g0met[5][ii][jj] ; 
                A0 = g0met[6][ii][jj] ; 
                
				EqX[0] = T - T0 ; 
                EqX[1] = V - V0 ; 
                EqX[2] = B - B0 ; 
                EqX[3] = S - S0 ; 
                EqX[4] = F - F0 ; 
                EqX[5] = U - U0 ; 
                EqX[6] = A - A0 ;
                 
                 
                
                //EqX[0] = Tx ; 
                //EqX[1] = Vx ; 
                EqX[2] = Bx ; 
                EqX[3] = Sx ; 
                EqX[4] = Fx ; 
                EqX[5] = Ux ; 
                EqX[6] = Ax ;
                  
				
			} else if(jj==NX-1 && ii>0) {
                
                z=patch[ii][jj][0] ; x=patch[ii][jj][1] ;

                T = gmet[0][ii][jj] ; Tx = dvx[0][ii][jj] ;
                V = gmet[1][ii][jj] ; Vx = dvx[1][ii][jj] ; 
                B = gmet[2][ii][jj] ; Bx = dvx[2][ii][jj] ; 
                S = gmet[3][ii][jj] ; Sx = dvx[3][ii][jj] ; 	
                F = gmet[4][ii][jj] ; Fx = dvx[4][ii][jj] ; 
                U = gmet[5][ii][jj] ; Ux = dvx[5][ii][jj] ; 
                A = gmet[6][ii][jj] ; Ax = dvx[6][ii][jj] ; 

                T0 = g0met[0][ii][jj] ; 
                V0 = g0met[1][ii][jj] ; 
                B0 = g0met[2][ii][jj] ; 
                S0 = g0met[3][ii][jj] ; 	
                F0 = g0met[4][ii][jj] ; 
                U0 = g0met[5][ii][jj] ; 
                A0 = g0met[6][ii][jj] ; 
               
                
				EqX[0] = T - T0 ; 
                EqX[1] = V - V0 ; 
                EqX[2] = B - B0 ; 
                EqX[3] = S - S0 ; 
                EqX[4] = F - F0 ; 
                EqX[5] = U - U0 ; 
                EqX[6] = A - A0 ;
                
                /*EqX[0] = Tx ; 
                EqX[1] = Vx ; 
                EqX[2] = Bx ; 
                EqX[3] = Sx ; 
                EqX[4] = Fx ; 
                EqX[5] = Ux ; 
                EqX[6] = Ax ;*/
                
				
			} else {
                
                
                z=patch[ii][jj][0] ; x=patch[ii][jj][1] ;
                
                
                T = gmet[0][ii][jj] ; Tz = dvz[0][ii][jj] ; Tx = dvx[0][ii][jj] ;
                V = gmet[1][ii][jj] ; Vz = dvz[1][ii][jj] ; Vx = dvx[1][ii][jj] ; 
                B = gmet[2][ii][jj] ; Bz = dvz[2][ii][jj] ; Bx = dvx[2][ii][jj] ; 
                S = gmet[3][ii][jj] ; Sz = dvz[3][ii][jj] ; Sx = dvx[3][ii][jj] ; 	
                F = gmet[4][ii][jj] ; Fz = dvz[4][ii][jj] ; Fx = dvx[4][ii][jj] ; 
                U = gmet[5][ii][jj] ; Uz = dvz[5][ii][jj] ; Ux = dvx[5][ii][jj] ; 
                A = gmet[6][ii][jj] ; Az = dvz[6][ii][jj] ; Ax = dvx[6][ii][jj] ; 
                
                Tzz = dvzz[0][ii][jj] ; Txx = dvxx[0][ii][jj] ; Tzx = dvzx[0][ii][jj] ;
                Vzz = dvzz[1][ii][jj] ; Vxx = dvxx[1][ii][jj] ; Vzx = dvzx[1][ii][jj] ;			
                Bzz = dvzz[2][ii][jj] ; Bxx = dvxx[2][ii][jj] ; Bzx = dvzx[2][ii][jj] ;
                Szz = dvzz[3][ii][jj] ; Sxx = dvxx[3][ii][jj] ; Szx = dvzx[3][ii][jj] ;			
                Fzz = dvzz[4][ii][jj] ; Fxx = dvxx[4][ii][jj] ; Fzx = dvzx[4][ii][jj] ;
                Uzz = dvzz[5][ii][jj] ; Uxx = dvxx[5][ii][jj] ; Uzx = dvzx[5][ii][jj] ;
                Azz = dvzz[6][ii][jj] ; Axx = dvxx[6][ii][jj] ; Azx = dvzx[6][ii][jj] ;
                
                T0 = g0met[0][ii][jj] ; T0z = dv0z[0][ii][jj] ; T0x = dv0x[0][ii][jj] ;
                V0 = g0met[1][ii][jj] ; V0z = dv0z[1][ii][jj] ; V0x = dv0x[1][ii][jj] ; 
                B0 = g0met[2][ii][jj] ; B0z = dv0z[2][ii][jj] ; B0x = dv0x[2][ii][jj] ; 
                S0 = g0met[3][ii][jj] ; S0z = dv0z[3][ii][jj] ; S0x = dv0x[3][ii][jj] ; 	
                F0 = g0met[4][ii][jj] ; F0z = dv0z[4][ii][jj] ; F0x = dv0x[4][ii][jj] ; 
                U0 = g0met[5][ii][jj] ; U0z = dv0z[5][ii][jj] ; U0x = dv0x[5][ii][jj] ; 
                A0 = g0met[6][ii][jj] ; A0z = dv0z[6][ii][jj] ; A0x = dv0x[6][ii][jj] ; 
                
                T0zz = dv0zz[0][ii][jj] ; T0xx = dv0xx[0][ii][jj] ; T0zx = dv0zx[0][ii][jj] ;
                V0zz = dv0zz[1][ii][jj] ; V0xx = dv0xx[1][ii][jj] ; V0zx = dv0zx[1][ii][jj] ;			
                B0zz = dv0zz[2][ii][jj] ; B0xx = dv0xx[2][ii][jj] ; B0zx = dv0zx[2][ii][jj] ;
                S0zz = dv0zz[3][ii][jj] ; S0xx = dv0xx[3][ii][jj] ; S0zx = dv0zx[3][ii][jj] ;			
                F0zz = dv0zz[4][ii][jj] ; F0xx = dv0xx[4][ii][jj] ; F0zx = dv0zx[4][ii][jj] ;
                U0zz = dv0zz[5][ii][jj] ; U0xx = dv0xx[5][ii][jj] ; U0zx = dv0zx[5][ii][jj] ;
                A0zz = dv0zz[6][ii][jj] ; A0xx = dv0xx[6][ii][jj] ; A0zx = dv0zx[6][ii][jj] ;
                
                
#include "BackgndFns8.c"  			
                                
                
#include "EqnAnsatz7.c"
                
            }
			
			for(var=0;var<7;var++) {
				
				val = EqX[var] ;
                
				if( (pos=mask[var][ii][jj]) != -1) {
					
					vecRptr[pos] = val ;
					
					RF[var][ii][jj] = val ;
					
				}	
				
			}
			
		}
	}
    
    
	
}




void calcLich(void)
{
    
    
	int ii, jj, ii2, jj2, var, var2 ;
	
	long posii, posjj, posLich ;
	
	double val ;
	
	double coeffzz, coeffxx, coeffzx, dEqXz[7][7], dEqXx[7][7], dEqT[7], dEqV[7], dEqB[7], dEqS[7], dEqF[7], dEqU[7], dEqA[7] ;
	
	double z, x ;
	
	double T, Tz, Tx, Tzz, Txx, Tzx ;
	double V, Vz, Vx, Vzz, Vxx, Vzx ;
	double B, Bz, Bx, Bzz, Bxx, Bzx ;
	double S, Sz, Sx, Szz, Sxx, Szx ;
	double F, Fz, Fx, Fzz, Fxx, Fzx ;
	double U, Uz, Ux, Uzz, Uxx, Uzx ;
	double A, Az, Ax, Azz, Axx, Azx ;
		
    double T0, T0z, T0x, T0zz, T0xx, T0zx ;
	double V0, V0z, V0x, V0zz, V0xx, V0zx ;
	double B0, B0z, B0x, B0zz, B0xx, B0zx ;
	double S0, S0z, S0x, S0zz, S0xx, S0zx ;
	double F0, F0z, F0x, F0zz, F0xx, F0zx ;
	double U0, U0z, U0x, U0zz, U0xx, U0zx ;
	double A0, A0z, A0x, A0zz, A0xx, A0zx ;
    
	posLich = 0 ;
	
	
	for(posii=0;posii<vecsize;posii++) {
		
		var = vecpos[posii][0] ;
		ii = vecpos[posii][1] ;
		jj = vecpos[posii][2] ;
		
		if(jj==0) {
			
			for(posjj=0;posjj<vecsize;posjj++) {
				
				var2 = vecpos[posjj][0] ;
				ii2 = vecpos[posjj][1] ;
				jj2 = vecpos[posjj][2] ;

                // All Neumann. T Dirichlet.                
				
                if( (var==0 || var==1) && var==var2 && ii==ii2 && jj==jj2) {
                    
                    val = 1. ;
                    
					LichRow[posLich] = posii ;
					LichCol[posLich] = posjj ;
					Lich[posLich]    = val ;
					
					posLich += 1 ;
					
					if(posLich>=NMAX3) {
						printf("posLich too large!\n") ; exit(1) ;
					}				
					
				} else if( (var!=0 && var!=1) && var==var2 && ii==ii2) {	
                    
                    val = DXmat[0][jj2] ;
                    
					LichRow[posLich] = posii ;
					LichCol[posLich] = posjj ;
					Lich[posLich]    = val ;
					
					posLich += 1 ;
					
					if(posLich>=NMAX3) {
						printf("posLich too large!\n") ; exit(1) ;
					}				
					
				}
				
			}
			
			
		} else if(jj==NX-1) {
			
			for(posjj=0;posjj<vecsize;posjj++) {
				
				var2 = vecpos[posjj][0] ;
				ii2 = vecpos[posjj][1] ;
				jj2 = vecpos[posjj][2] ;
 
// S, V Neumann. Others Dirichlet.                
                
                if( (0==0) && var==var2 && ii==ii2 && jj==jj2) {
                    
                    val = 1. ;
                    
					LichRow[posLich] = posii ;
					LichCol[posLich] = posjj ;
					Lich[posLich]    = val ;
					
					posLich += 1 ;
					
					if(posLich>=NMAX3) {
						printf("posLich too large!\n") ; exit(1) ;
					}				
					
				} else if( (0!=0) && var==var2 && ii==ii2) {	
                     
                     val = DXmat[NX-1][jj2] ;
                    
					LichRow[posLich] = posii ;
					LichCol[posLich] = posjj ;
					Lich[posLich]    = val ;
					
					posLich += 1 ;
					
					if(posLich>=NMAX3) {
						printf("posLich too large!\n") ; exit(1) ;
					}				
					
				}
				
			}
			
		}  else {
            
            
            
            z=patch[ii][jj][0] ; x=patch[ii][jj][1] ;
            

            T = gmet[0][ii][jj] ; Tz = dvz[0][ii][jj] ; Tx = dvx[0][ii][jj] ;
            V = gmet[1][ii][jj] ; Vz = dvz[1][ii][jj] ; Vx = dvx[1][ii][jj] ; 
            B = gmet[2][ii][jj] ; Bz = dvz[2][ii][jj] ; Bx = dvx[2][ii][jj] ; 
            S = gmet[3][ii][jj] ; Sz = dvz[3][ii][jj] ; Sx = dvx[3][ii][jj] ; 	
            F = gmet[4][ii][jj] ; Fz = dvz[4][ii][jj] ; Fx = dvx[4][ii][jj] ; 
            U = gmet[5][ii][jj] ; Uz = dvz[5][ii][jj] ; Ux = dvx[5][ii][jj] ; 
            A = gmet[6][ii][jj] ; Az = dvz[6][ii][jj] ; Ax = dvx[6][ii][jj] ; 
            
            Tzz = dvzz[0][ii][jj] ; Txx = dvxx[0][ii][jj] ; Tzx = dvzx[0][ii][jj] ;
            Vzz = dvzz[1][ii][jj] ; Vxx = dvxx[1][ii][jj] ; Vzx = dvzx[1][ii][jj] ;			
            Bzz = dvzz[2][ii][jj] ; Bxx = dvxx[2][ii][jj] ; Bzx = dvzx[2][ii][jj] ;
            Szz = dvzz[3][ii][jj] ; Sxx = dvxx[3][ii][jj] ; Szx = dvzx[3][ii][jj] ;			
            Fzz = dvzz[4][ii][jj] ; Fxx = dvxx[4][ii][jj] ; Fzx = dvzx[4][ii][jj] ;
            Uzz = dvzz[5][ii][jj] ; Uxx = dvxx[5][ii][jj] ; Uzx = dvzx[5][ii][jj] ;
            Azz = dvzz[6][ii][jj] ; Axx = dvxx[6][ii][jj] ; Azx = dvzx[6][ii][jj] ;
            
            
            T0 = g0met[0][ii][jj] ; T0z = dv0z[0][ii][jj] ; T0x = dv0x[0][ii][jj] ;
            V0 = g0met[1][ii][jj] ; V0z = dv0z[1][ii][jj] ; V0x = dv0x[1][ii][jj] ; 
            B0 = g0met[2][ii][jj] ; B0z = dv0z[2][ii][jj] ; B0x = dv0x[2][ii][jj] ; 
            S0 = g0met[3][ii][jj] ; S0z = dv0z[3][ii][jj] ; S0x = dv0x[3][ii][jj] ; 	
            F0 = g0met[4][ii][jj] ; F0z = dv0z[4][ii][jj] ; F0x = dv0x[4][ii][jj] ; 
            U0 = g0met[5][ii][jj] ; U0z = dv0z[5][ii][jj] ; U0x = dv0x[5][ii][jj] ; 
            A0 = g0met[6][ii][jj] ; A0z = dv0z[6][ii][jj] ; A0x = dv0x[6][ii][jj] ; 
            
            T0zz = dv0zz[0][ii][jj] ; T0xx = dv0xx[0][ii][jj] ; T0zx = dv0zx[0][ii][jj] ;
            V0zz = dv0zz[1][ii][jj] ; V0xx = dv0xx[1][ii][jj] ; V0zx = dv0zx[1][ii][jj] ;			
            B0zz = dv0zz[2][ii][jj] ; B0xx = dv0xx[2][ii][jj] ; B0zx = dv0zx[2][ii][jj] ;
            S0zz = dv0zz[3][ii][jj] ; S0xx = dv0xx[3][ii][jj] ; S0zx = dv0zx[3][ii][jj] ;			
            F0zz = dv0zz[4][ii][jj] ; F0xx = dv0xx[4][ii][jj] ; F0zx = dv0zx[4][ii][jj] ;
            U0zz = dv0zz[5][ii][jj] ; U0xx = dv0xx[5][ii][jj] ; U0zx = dv0zx[5][ii][jj] ;
            A0zz = dv0zz[6][ii][jj] ; A0xx = dv0xx[6][ii][jj] ; A0zx = dv0zx[6][ii][jj] ;
            
            
#include "BackgndFns8.c"  			
            
#include "LicheqAnsatz7.c"
            
			
			for(posjj=0;posjj<vecsize;posjj++) {
				
				var2 = vecpos[posjj][0] ;
				ii2 = vecpos[posjj][1] ;
				jj2 = vecpos[posjj][2] ;
				
				val = 0 ;
				
				if( ii==ii2 && jj==jj2 ) {
					
					switch(var2) {
							
						case(0) :
							
							val += dEqT[var] ;
							
							break ;
                            
                        case(1) :
							
							val += dEqV[var] ;
							
							break ;
							
						case(2) :
							
							val += dEqB[var] ;
							
							break ;
							
						case(3) :
							
							val += dEqS[var] ;
							
							break ;
							
						case(4) :
							
							val += dEqF[var] ;
							
							break ;
							
						case(5) :
							
							val += dEqU[var] ;
							
							break ;
                            
                        case(6) :
							
							val += dEqA[var] ;
							
							break ;
							
					}
					
				}
				
				
				if( jj==jj2 ) {
					
					if(var==var2)  val += coeffzz*DZ2mat[ii][ii2] ;
					
					val += dEqXz[var][var2]*DZmat[ii][ii2] ;
					
				}
				
				
				
				if( ii==ii2 ) {
					
					if(var==var2)  val += coeffxx*DX2mat[jj][jj2] ;
					
					val += dEqXx[var][var2]*DXmat[jj][jj2] ;
					
				}
				
				if(var==var2)  {
                    
                    
                    val += coeffzx*DZmat[ii][ii2]*DXmat[jj][jj2] ;
                    
					
				}
                
  				if(fabs(val)>LICHCUT) {	
					
					LichRow[posLich] = posii ;
					LichCol[posLich] = posjj ;
					Lich[posLich]    = val ;
					
					posLich += 1 ;
					
					if(posLich>=NMAX3) {
						printf("posLich too large!\n") ; exit(1) ;
					}				
					
					
				}
				
				
			}
			
			
		}
		
	}
	
	
	sizeLich = posLich ;
	
	
	printf("\nAnalytic: Size of Lich:  sizeLich = %ld\n",sizeLich) ;
    
    
	
}






void calcPhi(void)
{
	int ii, jj, var, kk ;
    
	double z, x ;
	
	double T, Tz, Tx, Tzz, Txx, Tzx ;
	double V, Vz, Vx, Vzz, Vxx, Vzx ;
	double B, Bz, Bx, Bzz, Bxx, Bzx ;
	double S, Sz, Sx, Szz, Sxx, Szx ;
	double F, Fz, Fx, Fzz, Fxx, Fzx ;
	double U, Uz, Ux, Uzz, Uxx, Uzx ;
	double A, Az, Ax, Azz, Axx, Azx ;
	
    double T0, T0z, T0x, T0zz, T0xx, T0zx ;
	double V0, V0z, V0x, V0zz, V0xx, V0zx ;
	double B0, B0z, B0x, B0zz, B0xx, B0zx ;
	double S0, S0z, S0x, S0zz, S0xx, S0zx ;
	double F0, F0z, F0x, F0zz, F0xx, F0zx ;
	double U0, U0z, U0x, U0zz, U0xx, U0zx ;
	double A0, A0z, A0x, A0zz, A0xx, A0zx ;
    
    double hv, hz, hx ;
    
    double phival, Riccival, R2sqrval, C4sqrval ; ;
    
	double gd[5][5], gu[5][5], R2[5][5], C4[5][5][5][5] ;
    
    int i1,i2,i3,i4, s1, s2, s3, s4 ;
    
    phimax = 0 ; Riccimax = 0. ; R2max = 0. ;

    
	for(ii=1;ii<NZ-1;ii++) {
		for(jj=1;jj<NX-1;jj++) {
			
			z=patch[ii][jj][0] ; x=patch[ii][jj][1] ;

              
			T = gmet[0][ii][jj] ; Tz = dvz[0][ii][jj] ; Tx = dvx[0][ii][jj] ;
			V = gmet[1][ii][jj] ; Vz = dvz[1][ii][jj] ; Vx = dvx[1][ii][jj] ; 
			B = gmet[2][ii][jj] ; Bz = dvz[2][ii][jj] ; Bx = dvx[2][ii][jj] ; 
			S = gmet[3][ii][jj] ; Sz = dvz[3][ii][jj] ; Sx = dvx[3][ii][jj] ; 	
			F = gmet[4][ii][jj] ; Fz = dvz[4][ii][jj] ; Fx = dvx[4][ii][jj] ; 
			U = gmet[5][ii][jj] ; Uz = dvz[5][ii][jj] ; Ux = dvx[5][ii][jj] ; 
			A = gmet[6][ii][jj] ; Az = dvz[6][ii][jj] ; Ax = dvx[6][ii][jj] ; 
           
			Tzz = dvzz[0][ii][jj] ; Txx = dvxx[0][ii][jj] ; Tzx = dvzx[0][ii][jj] ;
			Vzz = dvzz[1][ii][jj] ; Vxx = dvxx[1][ii][jj] ; Vzx = dvzx[1][ii][jj] ;			
			Bzz = dvzz[2][ii][jj] ; Bxx = dvxx[2][ii][jj] ; Bzx = dvzx[2][ii][jj] ;
			Szz = dvzz[3][ii][jj] ; Sxx = dvxx[3][ii][jj] ; Szx = dvzx[3][ii][jj] ;			
			Fzz = dvzz[4][ii][jj] ; Fxx = dvxx[4][ii][jj] ; Fzx = dvzx[4][ii][jj] ;
			Uzz = dvzz[5][ii][jj] ; Uxx = dvxx[5][ii][jj] ; Uzx = dvzx[5][ii][jj] ;
			Azz = dvzz[6][ii][jj] ; Axx = dvxx[6][ii][jj] ; Azx = dvzx[6][ii][jj] ;
            
            
            T0 = g0met[0][ii][jj] ; T0z = dv0z[0][ii][jj] ; T0x = dv0x[0][ii][jj] ;
            V0 = g0met[1][ii][jj] ; V0z = dv0z[1][ii][jj] ; V0x = dv0x[1][ii][jj] ; 
            B0 = g0met[2][ii][jj] ; B0z = dv0z[2][ii][jj] ; B0x = dv0x[2][ii][jj] ; 
            S0 = g0met[3][ii][jj] ; S0z = dv0z[3][ii][jj] ; S0x = dv0x[3][ii][jj] ; 	
            F0 = g0met[4][ii][jj] ; F0z = dv0z[4][ii][jj] ; F0x = dv0x[4][ii][jj] ; 
            U0 = g0met[5][ii][jj] ; U0z = dv0z[5][ii][jj] ; U0x = dv0x[5][ii][jj] ; 
            A0 = g0met[6][ii][jj] ; A0z = dv0z[6][ii][jj] ; A0x = dv0x[6][ii][jj] ; 
            
            T0zz = dv0zz[0][ii][jj] ; T0xx = dv0xx[0][ii][jj] ; T0zx = dv0zx[0][ii][jj] ;
            V0zz = dv0zz[1][ii][jj] ; V0xx = dv0xx[1][ii][jj] ; V0zx = dv0zx[1][ii][jj] ;			
            B0zz = dv0zz[2][ii][jj] ; B0xx = dv0xx[2][ii][jj] ; B0zx = dv0zx[2][ii][jj] ;
            S0zz = dv0zz[3][ii][jj] ; S0xx = dv0xx[3][ii][jj] ; S0zx = dv0zx[3][ii][jj] ;			
            F0zz = dv0zz[4][ii][jj] ; F0xx = dv0xx[4][ii][jj] ; F0zx = dv0zx[4][ii][jj] ;
            U0zz = dv0zz[5][ii][jj] ; U0xx = dv0xx[5][ii][jj] ; U0zx = dv0zx[5][ii][jj] ;
            A0zz = dv0zz[6][ii][jj] ; A0xx = dv0xx[6][ii][jj] ; A0zx = dv0zx[6][ii][jj] ;

            
#include "BackgndFns8.c"  			            

#include "Phi7.c"  	    
			            
            phi[ii][jj] = phival ;
            
#include "Curv8.c"

            Riccival = 0. ;
            for(i1=0;i1<5;i1++) {
                for(s1=0;s1<5;s1++) {
                    Riccival += R2[i1][s1]*gu[i1][s1] ;
                }
            }
            
            R2sqrval = 0. ;
            for(i1=0;i1<5;i1++) {
                for(i2=0;i2<5;i2++) {
                    if(R2[i1][i2]!=0.) {
                        for(s1=0;s1<5;s1++) {
                            for(s2=0;s2<5;s2++) {
                                R2sqrval += R2[i1][i2]*R2[s1][s2]*gu[i1][s1]*gu[i2][s2] ;
                            }
                        }
                    }
                }
            }
            
            C4sqrval = 0. ;
            
			
			for(i1=0;i1<5;i1++) {
				for(i2=0;i2<5;i2++) {
					for(i3=0;i3<5;i3++) {
						for(i4=0;i4<5;i4++) {
							if(C4[i1][i2][i3][i4]!=0.) {
								for(s1=0;s1<5;s1++) {
									for(s2=0;s2<5;s2++) {
										for(s3=0;s3<5;s3++) {
											for(s4=0;s4<5;s4++) {
												C4sqrval += C4[i1][i2][i3][i4]*C4[s1][s2][s3][s4]*gu[i1][s1]*gu[i2][s2]*gu[i3][s3]*gu[i4][s4] ;
											}
										}
									}
								}
							}
						}
					}
				}
			}
			
			
            
            
            Ricci[ii][jj] = Riccival+20. ;
            
            R2sqr[ii][jj] = R2sqrval-80. ;
            
            C4sqr[ii][jj] = C4sqrval ;
            
            if( phival > phimax ) phimax = phival ;
            
            if( fabs(Riccival) > fabs(Riccimax) && ii>0 && ii<NZ-1 && jj>0 && jj<NX-1 ) Riccimax = Riccival ;
            
            if( fabs(R2sqrval) > fabs(R2max) && ii>0 && ii<NZ-1 && jj>0 && jj<NX-1  ) R2max = R2sqrval ;
			
			
		}
	}
    
    	
}





void getG(void)
{
	int ii, jj, var ;
	long pos ;
	
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			for(var=0;var<7;var++) {
				
				if( (pos = mask[var][ii][jj]) == -1 ) continue ;
				
				vecG[pos] = gmet[var][ii][jj] ;
				
			}
			
		}
	}	
	
}


void updateG(double mult, double *vecptr)
{
	long pos ;
	
	for(pos=0;pos<vecsize;pos++) {
		
		vecG[pos] += mult*vecptr[pos] ;
		
	}	
	
}



void storeG(void)
{
	long pos ;
	int var,ii,jj ;
	
	for(pos=0;pos<vecsize;pos++) {
		
		var   = vecpos[pos][0] ; 
		ii    = vecpos[pos][1] ; 
		jj    = vecpos[pos][2] ; 
		
		gmet[var][ii][jj] = vecG[pos] ;
					
	}
	
}



void initpatches(void)
{
	int ii, jj, var, chk ;
	int intbuf ;
	double buf ;
	
	FILE *file ;
	
	
	vecsize = 0 ;
	
	
	file = fopen("patch.dat","r") ;
	
	if(file==NULL) { printf("\n\nError opening patch\n\n") ; exit(1) ; }
	
	fread(&NZ, sizeof(int), 1, file) ; fread(&NX, sizeof(int), 1, file) ; 
	
	if( NZ>NMAX || NX>NMAX ) { printf("\n\nPatch too large!\n\n") ; exit(1) ; }
	
	for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			chk = 0 ;
            
			for(var=0;var<7;var++) {
				chk += fread(&intbuf, sizeof(int), 1, file) ; mask[var][ii][jj] = intbuf ;
				if(intbuf!=-1) {
					if(intbuf>=NMAX2) {
                        
                        printf(" %d \n\n",intbuf) ;
                        
						printf("Vector size too large! %d\n\n",intbuf) ; exit(1) ;
					}
					vecpos[intbuf][0] = var ;
					vecpos[intbuf][1] = ii ;
					vecpos[intbuf][2] = jj ;
					if(intbuf>vecsize) vecsize = intbuf ;
				}
			}
			if(chk!=7) { printf("\n\nError in patch file - %d, %d, %d\n\n",ii,jj,chk) ; exit(1) ; }
			
		}
	}
	
	fclose(file) ;
	
	vecsize += 1 ;
	
	printf("Vector size = %ld\n",vecsize) ;
		
	
}




void save(void)
{
	int ii,jj,var ;
    long posii, posjj, posLich ;
	double buf, val ;
    
    
	for(var=0;var<7;var++) {
		for(ii=0;ii<NZ;ii++) {
			for(jj=0;jj<NX;jj++) {
                
				buf = (double) gmet[var][ii][jj] ;
				fwrite(&buf, sizeof(double), 1, fileptr) ;	
				
			}
		}
	}
	
	fflush(fileptr) ; 	
    
    for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			buf = (double) phi[ii][jj] ;
			fwrite(&buf, sizeof(double), 1, fileptrphi) ;	
			
		}
	}
	
	fflush(fileptrphi) ; 	
	
    for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			buf = (double) Ricci[ii][jj] ;
			fwrite(&buf, sizeof(double), 1, fileptrRicci) ;	
			
		}
	}
	
	fflush(fileptrRicci) ; 
    
    for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			buf = (double) R2sqr[ii][jj] ;
			fwrite(&buf, sizeof(double), 1, fileptrR2sqr) ;	
			
		}
	}
	
	fflush(fileptrR2sqr) ; 
    
    for(ii=0;ii<NZ;ii++) {
		for(jj=0;jj<NX;jj++) {
			
			buf = (double) C4sqr[ii][jj] ;
			fwrite(&buf, sizeof(double), 1, fileptrC4sqr) ;	
			
		}
	}
	
	fflush(fileptrC4sqr) ; 
    
    
    for(var=0;var<5;var++) {
		for(ii=0;ii<NZ;ii++) {
			for(jj=0;jj<NX;jj++) {
                
				buf = (double) dvz[var][ii][jj] ;
				fwrite(&buf, sizeof(double), 1, fileptrDerivs) ;	
				
			}
		}
	} 
	
    for(var=0;var<5;var++) {
		for(ii=0;ii<NZ;ii++) {
			for(jj=0;jj<NX;jj++) {
                
				buf = (double) dvx[var][ii][jj] ;
				fwrite(&buf, sizeof(double), 1, fileptrDerivs) ;	
				
			}
		}
	} 
	
    
    for(var=0;var<5;var++) {
		for(ii=0;ii<NZ;ii++) {
			for(jj=0;jj<NX;jj++) {
                
				buf = (double) dvzz[var][ii][jj] ;
				fwrite(&buf, sizeof(double), 1, fileptrDerivs) ;	
				
			}
		}
	} 
    
    for(var=0;var<5;var++) {
		for(ii=0;ii<NZ;ii++) {
			for(jj=0;jj<NX;jj++) {
                
				buf = (double) dvxx[var][ii][jj] ;
				fwrite(&buf, sizeof(double), 1, fileptrDerivs) ;	
				
			}
		}
	} 
    
    for(var=0;var<5;var++) {
		for(ii=0;ii<NZ;ii++) {
			for(jj=0;jj<NX;jj++) {
                
				buf = (double) dvzx[var][ii][jj] ;
				fwrite(&buf, sizeof(double), 1, fileptrDerivs) ;	
				
			}
		}
	} 
    
    
	fflush(fileptrDerivs) ; 
    
    
	
	
}





double norm(double *vecin)
{
	int ii; 
	double tmpval, val ;
	
	for(val=0.0,ii=0;ii<vecsize;ii++) {
		tmpval = fabs(vecin[ii]) ;
		if(val<tmpval) val = tmpval ;
	}
	
	return(val) ;
}


void unpackLich(void)
{
    long posii, posjj, posLich ;
    double val ;
     
    for(posii=0;posii<vecsize;posii++) {
        for(posjj=0;posjj<vecsize+1;posjj++) {
            
            
#if LAPACK == 0
            
            Lmat[ posii*(vecsize+1) + posjj ] = 0 ;
                        
#else
            
            Lmat[ posjj*vecsize + posii ] = 0 ;
            
#endif
                
        }        
    }
    
	for(posLich=0;posLich<sizeLich;posLich++) {
		
		posii = LichRow[posLich] ;
		posjj = LichCol[posLich] ;
		val   = Lich[posLich] ;
		
#if LAPACK == 0
        
        Lmat[ posii*(1+vecsize) + posjj ] = val ;
        
#else
        
        Lmat[ posjj*vecsize + posii ] = val ;
        
#endif
        
    }

}



/* LAPACK solver */

void linsolveLAPACK(double *x, double *b)
{
    int N, NZhs, ldLmat, ldx, info ;
    int ipiv[NMAX2];
    
    long ii ;
    
    N    = vecsize ;
    NZhs = 1 ;
    ldLmat  = vecsize ;
    ldx  = vecsize ;
    
    for(ii=0;ii<vecsize;ii++) x[ii] = b[ii] ;
    
    dgesv_(&N, &NZhs, Lmat, &ldLmat, ipiv, x, &ldx, &info);
    
    if(info != 0) {
        
        printf("\n\nFailure to solve linear system - %d\n\n", info);
        
        exit(1) ;
        
    }
    
    
}


/* Full/Partial pivoting */

void linsolveDirect(double *x, double *b)
{
    long ii, jj, kk, iimax, jjmax ;
    
    int tmp, index[NMAX2] ;
    
    double maxval, val, y[NMAX2] ;
    
    double tmpval, tmp2, tmp3 ;
    long pos1, pos2 ;
    
    
    for(ii=0;ii<vecsize;ii++) { index[ii] = ii ; }
    
    for(ii=0;ii<vecsize;ii++) { Lmat[ ii*(vecsize+1) + vecsize ] = b[ii] ; } 
    

  
    
    printf("\n<") ;
    for(kk=0;kk<vecsize;kk++) if( kk%(vecsize/100)==0 ) printf(" ") ;
    printf(">\n") ;
    
    
    
    printf("\n<") ;
	for(kk=0;kk<vecsize;kk++) {
        if( kk%(vecsize/100)==0) printf(".") ; fflush(stdout) ;
        
    
        
// Partial pivot on rows
        
        maxval = 0 ; iimax = -1 ;
        
        for(ii=kk;ii<vecsize;ii++) {
            
            if( fabs( Lmat[ii*(vecsize+1)+kk] ) > maxval ) {
                
                maxval = fabs(Lmat[ii*(vecsize+1)+kk]) ;
                
                iimax = ii ;
                
            }
            
        }
        
        if( iimax == -1 ) {
            
            printf("\n\nSingular Lich matrix!\n\n") ;
            exit(1) ;
            
        }
        
// Swap rows

        for(jj=kk;jj<vecsize+1;jj++) {
            
            val = Lmat[iimax*(vecsize+1)+jj] ;
            
            Lmat[iimax*(vecsize+1)+jj] = Lmat[kk*(vecsize+1)+jj] ;
            
            Lmat[kk*(vecsize+1)+jj] = val ;
            
        }
        

        
        
        pos2 = kk*(vecsize+1)+kk+1 ;
 
        tmp3 = -1.L/Lmat[kk*(vecsize+1)+kk] ;
        
        for(ii=kk+1;ii<vecsize;ii++) {
            
            tmpval = Lmat[ii*(vecsize+1)+kk]*tmp3 ;
            
            pos1 = ii*(vecsize+1)+kk+1 ;
            
            if(tmpval==0) continue ;
            
            for(jj=0;jj<vecsize-kk;jj++) {
                
                tmp2 = Lmat[pos2+jj] ;
                
             // Slower!!  
                //if(tmp2==0.) continue ;
                
                Lmat[pos1+jj] += tmp2*tmpval ;
                
            }
            
            Lmat[ii*(vecsize+1)+kk] = 0 ;
            
        }
        
        
    }
    
    
    printf(">\n") ;
    
    
// Back substitution
    
    
    for(kk=vecsize-1;kk>=0;kk--) {
    
        y[kk] = Lmat[ kk*(vecsize+1)+vecsize ]   ;
        
        for(ii=kk+1;ii<vecsize;ii++) {
        
            y[kk] += - Lmat[kk*(vecsize+1)+ii]*y[ii] ; 
            
        }
        
        y[kk] /= Lmat[kk*(vecsize+1)+kk] ;
        
        x[index[kk]] = y[kk] ;

    }
    
}


// Wrapper

void linsolve(double *x, double *b)
{
    
#if LAPACK == 0
    
    linsolveDirect(x, b) ; 
    
#else
    
    linsolveLAPACK(x, b) ; 
    
#endif   
    
}



void linsolvechk(double *x, double *b)
{
    long ii, jj ;
    
    double val, y[NMAX2] ;

    
// Check accuracy
    
    val = 0 ;
    
    for(ii=0;ii<vecsize;ii++) {
        
        y[ii] = b[ii] ;
        
        for(jj=0;jj<vecsize;jj++) {
            
            
            #if LAPACK == 0
         
            y[ii] += - Lmat[ii*(vecsize+1)+jj]*x[jj] ; 
            
            #else
            
            y[ii] += - Lmat[jj*vecsize+ii]*x[jj] ; 
            
            #endif
            
        }
        
        if( fabs(y[ii]) > val ) val = fabs(y[ii]) ;
        
    }
    
        
    printf("\n   Lin solve check ->  %10.3e\n",val) ;
    
	
}




void setupgrid(void)
{
    int Neven ;
    
    int ii, jj, kk ;
    double x[NMAX], c1, c2 ;
    
    double Dmat[NMAX][NMAX], D2mat[NMAX][NMAX] ;
    
    
    /* Std - for z [ 0 1 ] */
    
    for(ii=0;ii<NZ;ii++) {
        
        x[ii] = (1 + cosl(PI*(((double) (NZ-ii))-1)/(((double) NZ)-1)) )/2 ;
        
    }
    
    for(ii=1;ii<NZ-1;ii++) {
		for(jj=1;jj<NZ-1;jj++) {
            
            if(ii==jj) 
                Dmat[ii][jj] = - (x[jj] - 0.5L)/(2*(1-x[jj])*x[jj]) ;
            else
                Dmat[ii][jj] = ((double) pow(-1,ii+jj))/( x[ii] - x[jj] ) ;
            
        }
    }
    
    Dmat[0][0] = - ( 2*((double) pow(NZ-1,2)) + 1 )/3 ;
    
    for(jj=1;jj<NZ-1;jj++) {
        
        Dmat[0][jj] = -2*((double) pow(-1,jj))/x[jj] ;
        
    }
    
    Dmat[0][NZ-1] = - pow(-1,NZ-1) ;
    
    Dmat[NZ-1][NZ-1] = + ( 2*((double) pow(NZ-1,2)) + 1 )/3 ;
    
    for(jj=1;jj<NZ-1;jj++) {
        
        Dmat[NZ-1][jj] = 2*((double) pow(-1,NZ+jj-1))/(1 - x[jj]) ;
        
    }
    
    Dmat[NZ-1][0] = + pow(-1,NZ-1) ;
    
    for(ii=1;ii<NZ-1;ii++) {
        
        Dmat[ii][0] = +((double) pow(-1,ii))/x[ii]/2 ;
        
    }
    
    for(ii=1;ii<NZ-1;ii++) {
        
        Dmat[ii][NZ-1] = - ((double) pow(-1,NZ+ii-1))/(1 - x[ii])/2 ;
        
    }
    
    for(ii=0;ii<NZ;ii++) {
        for(jj=0;jj<NZ;jj++) {
            
            D2mat[ii][jj] = 0 ;
            
            for(kk=0;kk<NZ;kk++) {
                D2mat[ii][jj] += Dmat[ii][kk]*Dmat[kk][jj] ;
            }
            
        }
    }
    
    for(ii=0;ii<NZ;ii++) {
        
		for(jj=0;jj<NX;jj++) {
            
            patch[ii][jj][0] = zmax*x[ii] ;
            
        }
        
    }
   
    for(ii=0;ii<NZ;ii++) {
        
		for(jj=0;jj<NZ;jj++) {
            
            DZmat[ii][jj] = (1/zmax)*Dmat[ii][jj] ; 
            
            DZ2mat[ii][jj] = (1/(zmax*zmax))*D2mat[ii][jj] ; 
            
        }
    }
    
    
    /* Std - for x [ -1 1 ]  */
    
    for(ii=0;ii<NX;ii++) {
        
        x[ii] = (1 + cosl(PI*(((double) (NX-ii))-1)/(((double) NX)-1)) )/2 ;
        
    }
    
    for(ii=1;ii<NX-1;ii++) {
		for(jj=1;jj<NX-1;jj++) {
            
            if(ii==jj) 
                Dmat[ii][jj] = - (x[jj] - 0.5L)/(2*(1-x[jj])*x[jj]) ;
            else
                Dmat[ii][jj] = ((double) pow(-1,ii+jj))/( x[ii] - x[jj] ) ;
            
        }
    }
    
    Dmat[0][0] = - ( 2*((double) pow(NX-1,2)) + 1 )/3 ;
    
    for(jj=1;jj<NX-1;jj++) {
        
        Dmat[0][jj] = -2*((double) pow(-1,jj))/x[jj] ;
        
    }
    
    Dmat[0][NX-1] = - pow(-1,NX-1) ;
    
    Dmat[NX-1][NX-1] = + ( 2*((double) pow(NX-1,2)) + 1 )/3 ;
    
    for(jj=1;jj<NX-1;jj++) {
        
        Dmat[NX-1][jj] = 2*((double) pow(-1,NX+jj-1))/(1 - x[jj]) ;
        
    }
    
    Dmat[NX-1][0] = + pow(-1,NX-1) ;
    
    for(ii=1;ii<NX-1;ii++) {
        
        Dmat[ii][0] = +((double) pow(-1,ii))/x[ii]/2 ;
        
    }
    
    for(ii=1;ii<NX-1;ii++) {
        
        Dmat[ii][NX-1] = - ((double) pow(-1,NX+ii-1))/(1 - x[ii])/2 ;
        
    }
    
    for(ii=0;ii<NX;ii++) {
        for(jj=0;jj<NX;jj++) {
            
            D2mat[ii][jj] = 0 ;
            
            for(kk=0;kk<NX;kk++) {
                D2mat[ii][jj] += Dmat[ii][kk]*Dmat[kk][jj] ;
            }
            
        }
    }
    
    
    for(ii=0;ii<NZ;ii++) {
        
		for(jj=0;jj<NX;jj++) {
            
            patch[ii][jj][1] = 2.*(x[jj]-0.5) ;
            
        }
        
    }

    for(ii=0;ii<NX;ii++) {
                
        for(jj=0;jj<NX;jj++) {
                    
                    
            DXmat[ii][jj] = 0.5*Dmat[ii][jj] ; 
            
            DX2mat[ii][jj] = 0.25*D2mat[ii][jj] ; 
            
            
        }
    }
    
    
    FILE *file ;
	
	file = fopen("grid.dat","w") ;
    
    fwrite(&NZ, sizeof(int), 1, file) ;	
    fwrite(&NX, sizeof(int), 1, file) ;	
 
    for(ii=0;ii<NZ;ii++) fwrite(&patch[ii][0][0], sizeof(double), 1, file) ;	
    for(jj=0;jj<NX;jj++) fwrite(&patch[0][jj][1], sizeof(double), 1, file) ;	
    
    fclose(file) ;

    
}




